<template>
  <div style="display: flex; justify-content: space-between;">
    <div style="text-align: left">
      <label>Фильтры: </label>
      <input v-model="searchTerm1" />
      <input v-model="searchTerm2" />
      <input v-model="searchTerm3" />
    </div>
    <div>
      <label>Набор</label>      
      <select v-model="selectedKit">
        <option v-for="item in kitList" :key="item">{{item}}</option>
      </select>
    </div>
    <div>
      <button style="background-color: red; color: white;" @click="runCmd('deleteItem')" >Удалить</button>
    </div>
  </div>
  <table-lite
    :is-static-mode=true
    :columns="table.columns"
    :rows="table.rows"
    :total="table.totalRecordCount"
    :messages="table.messages"
    :page="page"
    :page-size="pageSize"
    @get-now-page="setCurrentPage" 
    @get-now-page-size="setCurrentPageSize" 
    @is-finished="tableLoadingFinish"    
    >
  </table-lite>

  <loader :active="loaderActive" message="Загрузка данных" />  

  <div style="display: flex; justify-content: space-between;">
    <div style="display: flex; justify-content: left;">
      <div>
        <button @click="loadShape">Область</button>
        <input size="40" v-model="shapeFilePath" />
        <select v-model="selectedRegion">
            <option>Все</option>
            <option>adygea</option>
            <option>ever</option>
            <option>hakassia</option>
            <option>ivanovo</option>
            <option>kabardino</option>
            <option>kaliningrad</option>
            <option>kaluga</option>
            <option>karachaevo</option>
            <option>kemerovo</option>
            <option>krim</option>
            <option>lipetsk</option>
            <option>tatarstan</option>
            <option>tula</option>
            <option>tambov</option>
            <option>voroneg</option>
        </select>
        <button @click="find('intersection')">Пересечение</button>  
        <button @click="find('contain')">Покрытие</button>  
      </div>
    </div>  
    <div>
      <label>Отображать маршрутов</label>      
      <input size="3" v-model="maxBorderOnMap" />
    </div>
  </div>

  <label width="100%">{{ result }}</label>
  <div id="map">
      <yandex-map
          :coords="areaStart"
          :zoom="5"         
          :map-type="'map'"
          :controls="[]"
          style="height: 600px;"
          @map-was-initialized="onInitMap" 
          >
          <div v-for="item in jobCrop" v-bind:key="item.productId">
            <ymap-marker
              marker-id="1"
              :marker-type="'Polygon'"
              :coords="item"
              :marker-fill="{color: '#0000f0', opacity: 0.2}"
              :marker-stroke="{color: '#0000ff', width: 1}"
            >
            </ymap-marker>
          </div>

      </yandex-map>
  </div>

  <div>
      <button @click="drawImages()">Показать Квиклуки</button>  
  </div>  

  <div v-for="item in images" v-bind:key="item.name">
    <div style="display: flex; justify-content: space-between;">
      <label>{{item.name}}</label>
      <div>
        <label style="font-weight:bold">Cloud</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label >{{item.Cloud}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Water</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Water}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Snow</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Snow}}</label>
      </div>
       <div>
        <label style="font-weight:bold">Defects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Defects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">DDefects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.DDefects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Shadows</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Shadows}}</label>
      </div>
      <div>
        <label style="font-weight:bold">StitchingMs</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.StitchingMs}}</label>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.productQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.routeQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.summaryQualityStatus}}</a>
      </div>
    </div>   
   
    <a rel="nofollow" :href="item.rpath">
      <img :src="item.rpath" style="width:100%;"/>
      <p></p>
    </a>
  </div>

</template>

<script>
import { watch, defineComponent, reactive, ref, computed } from "vue";
import TableLite from "../components/TableLite";
import axios from 'axios';
import { redouteProvider } from  "../config/provider"
import { loadYmap } from 'vue-yandex-maps'
import Loader from '../components/Loader.vue'
import router from "../router/index.ts"

let map = null
export let polygon = null

let timerDrawBorder = null

var storePage = 1
var storePageSize = 5


// собственно табличные данные 
// храним в глобальнй области, чтобы не было удаления при переходе между страницами
export const data = reactive([]);

export let table = reactive({})

const searchTerm1 = ref(""); // Search text
const searchTerm2 = ref(""); // Search text
const searchTerm3 = ref(""); // Search text
const taskPrefix = ref(""); 
const version = ref(""); 
const params = ref("--type BYTE --format COG"); 
const result = ref('')
const selectedLevel = ref('L2')
const selectedRegion = ref('')
const selectedBandComb = ref('')
const selectedPriority = ref('NORMAL')
const   shapeFilePath = ref("/mnt/beegfs/TEST/all_region/krim.geojson")

function updateData(response, data, table) {
  table.messages.noDataAvailable = "Нет данных" 
  data.splice(0,data.length)
  response.data.forEach(element => data.push(element) )   
}

var kitList = reactive([])
var selectedKit = ref('')

export default defineComponent({ 
  name: "App",
  components: { TableLite, Loader },
  setup() {

    const   images = reactive([])
    const   jobCrop = reactive([])
    const   maxBorderOnMap = ref(50)
    const   loaderActive = ref(false)

    const pageSize = ref('')
    const page = ref("")
    page.value = storePage
    pageSize.value = storePageSize

    let  areaStart = reactive([39.8, 54.8]);

    watch(selectedRegion, () =>  {
      let k = shapeFilePath.value.lastIndexOf('/')
      if ( k>0 ) {
        shapeFilePath.value = shapeFilePath.value.replace(shapeFilePath.value.substring(k+1), selectedRegion.value + '.geojson')
      }
      let ka = ''
      if (searchTerm1.value) ka += '_' + searchTerm1.value
      if (searchTerm2.value) ka += '_' + searchTerm2.value
      if (searchTerm3.value) ka += '_' + searchTerm3.value
      taskPrefix.value = selectedRegion.value + ka
      loadShape()
    })

    watch(searchTerm1, () => { cleverDrawBorder() })
    watch(searchTerm2, () => { cleverDrawBorder() })
    watch(searchTerm3, () => { cleverDrawBorder() })
    watch(maxBorderOnMap, () => { cleverDrawBorder() })

    watch(selectedKit, () => loadKit())

    const dataServer = redouteProvider + '/catalog'
    const url = new URL(window.location.href)
    const kit = url.searchParams.get("kit")
    if (kit)
      selectedKit.value = kit

    if (selectedKit.value) {
      initList()
      loadKit()
    }
    else {
      if (data.length == 0) {
        axios.get(dataServer, {})
        .then(response => { updateData(response,data,table); initList(); } )
        .catch(error => table.messages.noDataAvailable = 'Сервер "' + dataServer + '" не отвечает ' + error)
      }
    }

    async function init(name) {
      const url = redouteProvider + '/files'
      let postData = { name: name }
      let sPost = JSON.stringify(postData)

      let list = null
      if (name == 'kit') list = kitList

      list.splice(0,list.length)
      let response = await axios.post(url, sPost);
      response.data.forEach(element => list.push(element) )   
    }

    function initList() {
      init('kit')
    }

    const onInitMap = (mapFrom) => {
      map = mapFrom; 
      loadYmap({})
      let coord = []
      newPolygon(coord)
      // Включаем режим редактирования с возможностью добавления новых вершин.
      polygon.editor.startDrawing()

    }

    function newPolygon(coordinates) {
      if (coordinates && coordinates.type && coordinates.type.toLowerCase() == 'polygon')
        coordinates.type = 'Polygon'
      polygon = new window.ymaps.Polygon(
        coordinates,
        {
          // balloonContentHeader: "Перейти к подбору маршрутов",
        },
        {
          strokeWidth: 6,
          strokeColor: '#000000',
          draggable: true,
          fillColor: '#FF0000',
          opacity: 0.4,
        });
    
      // Добавляем многоугольник на карту.
      map.geoObjects.add(polygon)

      // В режиме добавления новых вершин меняем цвет обводки многоугольника.
      var stateMonitor = new window.ymaps.Monitor(polygon.editor.state)
      stateMonitor.add('drawing', function (newValue) {
        polygon.options.set('strokeColor', newValue ? '#FF0000' : '#FF0000')
      })
    }

    function drawBorder()   {
      jobCrop.splice(0,jobCrop.length)
      // по отобранным маршрутам получаем контуры
      let rows = table.rows;
      let totalCrop = rows.length
      if (totalCrop > maxBorderOnMap.value) totalCrop = maxBorderOnMap.value
      if (totalCrop > 0) loaderActive.value = true;
      for (let i=0; i<totalCrop; i++) {
        let row = rows[i]
        let productId = row.product
        if (!productId) continue
        let request = redouteProvider + '/border?product_id=' + productId 
        axios.get(request, {})
          .then(response => { 
            if (response.data) {
              console.log(response.data)
              //let border = JSON.parse(response.data)
              let border = response.data
              let arPolygon = []
              arPolygon.push(border)
              jobCrop.push(border)
            }
        })
        .catch(error => { 
          console.log(error)
        })      
      }

      loaderActive.value = false;
    }

    function drawImages()   {
      images.splice(0,images.length)  

      let rows = table.rows;
      let totalCrop = rows.length
      if (totalCrop > maxBorderOnMap.value) totalCrop = maxBorderOnMap.value
      if (totalCrop > 0) loaderActive.value = true;
      for (let i=0; i<totalCrop; i++) {
        let row = rows[i]
        let productId = row.product
        if (!productId) continue

        let request = redouteProvider + '/images' + '?product_id=' + productId

        axios.get(request, {})
        .then(response => { 
          if (response.data && response.data.length > 0) {
            response.data.forEach(element => {
              element.rpath = redouteProvider+'/image?' + 'name=' + element.path
              element.qarpath = redouteProvider+'/file?' + 'name=' + element.qa
              images.push(element)
            })
          }
        })
        .catch(error => { 
          //table.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
          images.push({name:error})
        })
      }
      loaderActive.value = false;
    }

    function find(operation)  {
      let s = ''
      let coord = polygon.geometry.getCoordinates()[0]
      if (coord.length == 0) return
      areaStart.splice(0,2)
      areaStart.push(coord[0][0])
      areaStart.push(coord[0][1])
      let dataServer = redouteProvider + '/find'
      let postData = { polygon: coord , operation: operation }
      s = JSON.stringify(postData)
      axios.post(dataServer, s)
        .then(response => { updateData(response, data, table)
          data.splice(0,data.length)
          response.data.forEach(element => data.push(element) )
          drawBorder()
        })
        .catch(error =>  {
          alert(error.response.data)
        });  
    }

    // Table config
    table = reactive({
      columns: [
        {
          // !!! field не может содержать подстроку id - tableLite его не показыввет
          label: "product",
          field: "product",
          width: "20%",
          sortable: false,
          display: function (row) {
              return (
                '<a href="javascript:void(0)" data-id="' +
                row.product + 
                '" class="is-rows-el job-btn">' +
                row.product +
                "</a>"
              )
          },           
        },
        {
          label: "до уточнения",
          field: "refineBefore",
          width: "5%",
          sortable: true,
        },
        {
          label: "после",
          field: "refineAfter",
          width: "5%",
          sortable: true,
        },
        {
          label: "версия",
          field: "refineVersion",
          width: "5%",
          sortable: false,
        },
        {
          label: "датаL0",
          field: "archivingTime",
          width: "10%",
          sortable: false,
        },
        {
          label: "версияL0",
          field: "archivingVersion",
          width: "5%",
          sortable: false,
        },
        {
          label: "источник",
          field: "input",
          width: "5%",
          sortable: false,
        },
      ],
      rows: computed(() => {
        return data.filter(
          (x) => {
            let fields = [x.product, x.refineBefore, x.refineAfter, x.refineVersion, x.archivingTime, x.archivingVersion, x.input]
            let nameFilter = ok(fields,searchTerm1.value) && ok(fields,searchTerm2.value) && ok(fields,searchTerm3.value)
            return nameFilter
          }
        );
      }),

      totalRecordCount: computed(() => {
        return table.rows.length;
      }),
     
      messages: {
        pagingInfo: "{0}-{1}/{2}",
        pageSizeChangeLabel: "Строк:",
        gotoPageLabel: "Перейти:",
        noDataAvailable: "Получение данных ...",
      },      
     });

    const setCurrentPage = (pageNumber) => {
        storePage = pageNumber
      };

    const setCurrentPageSize = (pageSize) => {
        storePageSize = pageSize
      };
      
    function ok (fields, value) {
      if(!value) return true
      let ret = false
      for (let field of fields) {
        ret = field &&  field.toString().toLowerCase().includes(value.toLowerCase())
        if (ret) break
      }
      return ret  
    }

    function makeProduct()  {
      let dataServer = redouteProvider + '/' + 'make'

      // отобранные записи попадают в массив
      let arProduct = []
      let rows = table.rows;
      for (let row of rows) {
        arProduct.push(row.product)
      }

      let prefix = ''
      if (version.value) prefix = version.value
      if (taskPrefix.value) {
        if (prefix) prefix+='_'
        prefix += taskPrefix.value 
      }

      let postData = {  input:          arProduct,
                        level:          selectedLevel.value,
                        bandCombination:selectedBandComb.value,
                        polygon:        polygon.geometry.getCoordinates()[0],
                        taskPrefix:     prefix,
                        params:         params.value,
                        priority:       selectedPriority.value,
                     }

      // L2 без указания комбинации каналов - обработка для портала
      if (postData.level == 'L2' && !postData.bandCombination) {
        postData.polygon = null
        postData.params = postData.params += ' --portal'
      }

      axios.post(dataServer, JSON.stringify(postData)  )
        .then(function (response) {
          result.value = response.data
        })
        .catch(function (error) {
          result.value = error
        });  
    }

    function loadShape()  {
      let dataServer = redouteProvider + '/' + 'polygon'

      let postData = { path: shapeFilePath.value  }

      axios.post(dataServer, JSON.stringify(postData)  )
        .then(function (response) {
          let loadedShape = response.data
          map.geoObjects.remove(polygon)
          newPolygon(loadedShape)
          let coord = loadedShape.coordinates[0]
          if (coord.length == 0) return
          areaStart.splice(0,2)
          areaStart.push(coord[0][0])
          areaStart.push(coord[0][1])
        })
        .catch(function (error) {
          alert(error)
        });  
    }

    function cleverDrawBorder() {
      if (timerDrawBorder) clearTimeout(timerDrawBorder);
      timerDrawBorder = setTimeout(drawBorder,1000);
    }

    const tableLoadingFinish = (elements) => {
      table.isLoading = false;
      Array.prototype.forEach.call(elements, function (element) {
        if (element.classList.contains("job-btn")) {
          element.addEventListener("click", function () {
            goToJob2(this.dataset.id)
          });
        }
      });    
    }

    function goToJob2 (id) {
      // в строке хранятся 3 числа через запятую task,job,product
      let part = id.split(',')
      router.push({ path: '/job2', query: { product_id: part[0] } })
    }

    function goToKit() {
      if (!selectedKit.value) return
      loadKit()
/*      
      router.push({ path: '/catalog', query: { kit: selectedKit.value }})
        .then(() => {
          window.location.reload()
        })
*/          
    }

    function loadKit() {
      if (!selectedKit.value) return
      
      loaderActive.value = true
      const dataServer = redouteProvider + '/loadKit?name=' + selectedKit.value
      axios.get(dataServer, {})
        .then(response => { 
          updateData(response, data, table)
          drawBorder()
          loaderActive.value = false
        })
        .catch(error => { 
          table.messages.noDataAvailable = 'Сервер "' + dataServer + '" не отвечает ' + error
          loaderActive.value = false
        })

    }

    function runCmd(name) {
      if (!confirm('УДАЛЕНИЕ МАРШРУТОВ ИЗ КАТАЛОГОВ. \nВсего: ' + table.rows.length + '. \nПродолжить ?' )) return;

      let api = redouteProvider + '/' + name
      let rows = table.rows;
      let postData = { taskId: [] }
      for (let row of rows) 
        postData.taskId.push(row.product)
      axios.post(api,  JSON.stringify(postData))
          .then()
          .catch(error => { alert (error) })
    }


    return {
      tableLoadingFinish,
      searchTerm1,
      searchTerm2,
      searchTerm3,
      page, pageSize,
      setCurrentPage, setCurrentPageSize,
      table,
      onInitMap,
      find,
      result,
      areaStart,
      selectedLevel,
      selectedRegion,
      selectedBandComb,
      selectedPriority,
      makeProduct,
      taskPrefix,
      version,
      params,
      jobCrop,
      loaderActive,
      loadShape,
      shapeFilePath,
      maxBorderOnMap,
      images,
      drawImages,
      selectedKit,kitList,goToKit,
      runCmd,
    };
  },
});


</script>


<style scoped>

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.1rem;
    font-size: medium;
  }

  </style>

